package com.springboot.mongodb.entity;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import org.springframework.data.annotation.Id;
import org.springframework.data.annotation.Transient;
import org.springframework.data.mongodb.core.mapping.Document;
import org.springframework.data.mongodb.core.mapping.Field;
import org.springframework.stereotype.Component;

// Mongodb annotation
// marks a class for the domain object that we want to persist in the db
@Document(collection = "employees")
// Lombok annotations
@NoArgsConstructor
@AllArgsConstructor
@Builder
@Data
// Spring stereotype annotation
@Component
public class Employee {

    // causes the field to be excluded from being stored in the db
    @Transient
    public static final String SEQUENCE_NUMBER = "employee_sequence";

    @Id
    int id;
    @Field("first_name")
    String firstName;
    @Field("last_name")
    String lastName;
    String email;
    @Field("home_address")
    String homeAddress;
    @Field("phone_number")
    String phoneNumber;
    String gender;
}
