package com.springboot.mongodb.service;

import com.springboot.mongodb.entity.Employee;
import com.springboot.mongodb.repository.EmployeeRepo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class EmployeeService {

    @Autowired
    private EmployeeRepo repo;

    // save new employee record in the collection
    public void save(final Employee employee) {
        repo.save(employee);
    }

    // get a count of employee records from the collection
    public long getCollectionCount() {
        return repo.count();
    }

    // get all employees from the collection
    public List<Employee> getEmployees() {
        return repo.findAll();
    }

    // get all employees by the gender from the collection
    public List<Employee> getEmployeesByGender(final String gender) {
        return repo.findEmployeesByGender(gender);
    }
}
